module BaseFunctions where

import Prelude (between, (<>), (==))

import Data.Array as A
import Data.String.CodeUnits (singleton)

concat :: Char -> String -> String
concat c rest = singleton c <> rest

isDigit :: Char -> Boolean
isDigit = between '0' '9'

isLower :: Char -> Boolean
isLower = between 'a' 'z'

isUpper :: Char -> Boolean
isUpper = between 'A' 'Z'

isAlpha :: Char -> Boolean
isAlpha c = A.any (\f -> f c) [isLower, isUpper]

isAlphaNum :: Char -> Boolean
isAlphaNum c = A.any (\f -> f c) [isAlpha, isDigit]

isSpace :: Char -> Boolean
isSpace c = A.any (\v -> v == c) [' ', '\t', ' ', '\r', '\n']

